<rtflowfile version="1.0">
   <block name="SafeArctan2" folder="Standard\Arithmetic\" width="48" height="48">
      <resize constrainprop="false" allow="true"/>
      <instancename show="true" position="up"/>
      <blockname show="false" position="down"/>
      <portnames show="true" inside="true"/>
      <graphic class="rect" x1="0" y1="0" x2="48" y2="48">
         <fill fill="true" color="0x00EEEEEE"/>
      </graphic>
      <graphic class="text" x="24" y="24" size="10" s="arctan" showalways="true"/>
      <doc>Computes the angle of a two-dimensional vector and avoids math errors. The vector is given as a pair of real cartesian coordinates (x,y). The resulting signal o will be the angle of the given vector counterclockwise from the x-axis in radians and in the interval [-pi,+pi]. If the length of the vector is 0, the resulting signal o will be 0.</doc>
      <port name="y" type="real" x="0" y="16" kind="input" dir="left">
         <doc>Y-coordinate of the vector to calculate the angle of.</doc>
      </port>
      <port name="x" type="real" x="0" y="32" kind="input" dir="left">
         <doc>X-coordinate of the vector to calculate the angle of.</doc>
      </port>
      <port name="rad" type="real" x="48" y="16" kind="output" dir="right">
         <doc>The angle of the given vector in radians in the interval [-pi,+pi], or 0 if the length of (x,y) is 0.</doc>
      </port>
   </block>
   <schematic name="SafeArctan2" width="903" height="602">
      <editor gridsize="16" alignports="true" autovalue="false"/>
      <binstance name="Arctan1" block="Arctan2" x="400" y="64"/>
      <binstance name="Equal1" block="Equal" x="224" y="144"/>
      <binstance name="Equal2" block="Equal" x="224" y="192"/>
      <binstance name="y" block="RealInput" x="112" y="64"/>
      <binstance name="x" block="RealInput" x="112" y="112"/>
      <binstance name="If1" block="If" x="336" y="96"/>
      <binstance name="And1" block="And" x="288" y="160"/>
      <binstance name="Value1" block="Value" x="288" y="96">
         <constant name="value" value="1" show="true" x="16" y="8"/>
      </binstance>
      <binstance name="Value2" block="Value" x="176" y="160">
         <constant name="value" value="0" show="true" x="16" y="8"/>
      </binstance>
      <binstance name="Value3" block="Value" x="176" y="208">
         <constant name="value" value="0" show="true" x="16" y="8"/>
      </binstance>
      <binstance name="rad" block="RealOutput" x="496" y="72"/>
      <connection name="y" port1="y.o" port2="Arctan1.i0">
         <point x="128" y="72"/>
         <point x="400" y="72"/>
      </connection>
      <connection name="If1_o_1" port1="If1.o" port2="Arctan1.i1">
         <point x="368" y="112"/>
         <point x="384" y="112"/>
         <point x="384" y="88"/>
         <point x="400" y="88"/>
      </connection>
      <connection name="And1_o_1" port1="And1.o" port2="If1.i2">
         <point x="320" y="176"/>
         <point x="344" y="176"/>
         <point x="344" y="128"/>
      </connection>
      <connection name="x" port1="x.o" port2="If1.i0">
         <point x="128" y="120"/>
         <point x="336" y="120"/>
      </connection>
      <connection name="Equal1_o_1" port1="Equal1.o" port2="And1.i1">
         <point x="256" y="160"/>
         <point x="272" y="160"/>
         <point x="272" y="168"/>
         <point x="288" y="168"/>
      </connection>
      <connection name="Equal2_o_1" port1="Equal2.o" port2="And1.i0">
         <point x="256" y="208"/>
         <point x="272" y="208"/>
         <point x="272" y="184"/>
         <point x="288" y="184"/>
      </connection>
      <connection name="y" port1="y.o" port2="Equal1.i0">
         <point x="128" y="72"/>
         <point x="160" y="72"/>
         <point x="160" y="152"/>
         <point x="224" y="152"/>
      </connection>
      <connection name="x" port1="x.o" port2="Equal2.i0">
         <point x="128" y="120"/>
         <point x="144" y="120"/>
         <point x="144" y="200"/>
         <point x="224" y="200"/>
      </connection>
      <connection name="Value1_o_1" port1="Value1.o" port2="If1.i1">
         <point x="320" y="104"/>
         <point x="336" y="104"/>
      </connection>
      <connection name="Value2_o_1" port1="Value2.o" port2="Equal1.i1">
         <point x="208" y="168"/>
         <point x="224" y="168"/>
      </connection>
      <connection name="Value3_o_1" port1="Value3.o" port2="Equal2.i1">
         <point x="208" y="216"/>
         <point x="224" y="216"/>
      </connection>
      <connection name="rad" port1="Arctan1.o" port2="rad.i0">
         <point x="448" y="80"/>
         <point x="496" y="80"/>
      </connection>
   </schematic>
</rtflowfile>
